/*
 * "Hello World" example.
 *
 * This example prints 'Hello from Nios II' to the STDOUT stream. It runs on
 * the Nios II 'standard', 'full_featured', 'fast', and 'low_cost' example
 * designs. It runs with or without the MicroC/OS-II RTOS and requires a STDOUT
 * device in your system's hardware.
 * The memory footprint of this hosted application is ~69 kbytes by default
 * using the standard reference design.
 *
 * For a reduced footprint version of this template, and an explanation of how
 * to reduce the memory footprint for a given application, see the
 * "small_hello_world" template.
 *
 */

#include <stdio.h>

#include "altera_up_avalon_parallel_port.h"

int main()
{
	unsigned long int tmp;
	alt_up_parallel_port_dev* ledr;
	alt_up_parallel_port_dev* switches;

	ledr = alt_up_parallel_port_open_dev(RED_LED_NAME);
	switches = alt_up_parallel_port_open_dev(SWITCHES_NAME);

	tmp = alt_up_parallel_port_read_data(switches);
	alt_up_parallel_port_write_data(ledr, tmp);


  printf("Hello from Nios II!\n");



  return 0;
}
