/*
 * "Hello World" example.
 *
 * This example prints 'Hello from Nios II' to the STDOUT stream. It runs on
 * the Nios II 'standard', 'full_featured', 'fast', and 'low_cost' example
 * designs. It runs with or without the MicroC/OS-II RTOS and requires a STDOUT
 * device in your system's hardware.
 * The memory footprint of this hosted application is ~69 kbytes by default
 * using the standard reference design.
 *
 * For a reduced footprint version of this template, and an explanation of how
 * to reduce the memory footprint for a given application, see the
 * "small_hello_world" template.
 *
 */
#define _XOPEN_SOURCE   600
#define _POSIX_C_SOURCE 200112L

#include <stdio.h>
#include "altera_up_avalon_parallel_port.h"
#include "altera_up_avalon_character_lcd.h"

unsigned char decodeDigit(unsigned char n){
	switch(n){
	case 0: 	return 63;
	case 1: 	return 6;
	case 2: 	return 91;
	case 3:		return 79;
	case 4:		return 102;
	case 5:     return 109;
	case 6:		return 125;
	case 7:		return 7;
	case 8:		return 127;
	case 9:		return 111;
	default: 	return 0;
	}
}

 unsigned int decodeNumber(unsigned int m){
	int i = 1;
	unsigned char tmp = m%10;
	unsigned long long int result = decodeDigit(tmp); //pierwsza cyfra z prawej
	m = m/10;
	while(m != 0) {
		tmp = m%10;
		result += ((unsigned long long int)decodeDigit(tmp) << (8*i));
		printf("%d | %d || ", result, i);
		i++;
		m=m/10;
	}
	return result;
}
int main()
{
	alt_up_character_lcd_dev * char_lcd_dev;
	unsigned int tmp;

	alt_up_parallel_port_dev *s30;
	alt_up_parallel_port_dev *s74;

	alt_up_parallel_port_dev *ledr;
	alt_up_parallel_port_dev *switches;

	ledr = alt_up_parallel_port_open_dev(LEDR_NAME);
	s30 = alt_up_parallel_port_open_dev(SEG30_NAME);
	s74 = alt_up_parallel_port_open_dev(SEG74_NAME);
	switches =  alt_up_parallel_port_open_dev(SWITCHES_NAME);

	// open the Character LCD port
	char_lcd_dev = alt_up_character_lcd_open_dev (LCD_NAME);
	if( char_lcd_dev == NULL)
		alt_printf ("Error: could not open character LCD device\n");
	else
		alt_printf ("Opened character LCD device\n");
	/* Initialize the character display */
	alt_up_character_lcd_init (char_lcd_dev);
	/* Write "Welcome to" in the first row */
	alt_up_character_lcd_string(char_lcd_dev, "Welcome to");
	/* Write "the DE2 board" in the second row */
	char second_row[] = "na plycie DE2\0";
	alt_up_character_lcd_set_cursor_pos(char_lcd_dev, 0, 1);
	alt_up_character_lcd_string(char_lcd_dev, second_row);


  printf("Hello from Nios II!\n");

	while(1){
        usleep(10000);
        tmp = alt_up_parallel_port_read_data(switches);
        alt_up_parallel_port_write_data(ledr, tmp);
        alt_up_parallel_port_write_data(s30, decodeNumber(tmp));
        alt_up_parallel_port_write_data(s74, tmp);
        printf("%4d : %4d  |  %4x\n", tmp, decodeNumber(tmp), decodeNumber(tmp));
	}

  return 0;
}
