
#include <stdio.h>
#include "altera_up_avalon_character_lcd.h"
#include "altera_up_avalon_parallel_port.h"


unsigned char decodeDigit(unsigned char s){
	switch(s)
	{
	case 0: return 63;
	case 1: return 6;
	case 2: return 91;
	case 3: return 79;
	case 4: return 102;
	case 5: return 109;
	case 6: return 125;
	case 7: return 7;   // ;71; //lub 7
	case 8: return 127;
	case 9: return 111;
	default: return 0;
	}
}

int decodeNumber(unsigned int n)
{
	unsigned int tmp_int = 0;
	unsigned int shift = 0;
	int i;
	for( i = 0;i<4;i++){
		unsigned char tmp=n%10;
		tmp_int+=decodeDigit(tmp)<<shift;
		n=n/10;
		shift+=8;
		printf("%d %d\n",tmp,n);
	}
	return tmp_int;
}


int main()
{
	alt_up_character_lcd_dev * char_lcd_dev;
	unsigned int tmp;

	alt_up_parallel_port_dev *ledr;
	alt_up_parallel_port_dev *switches;
	alt_up_parallel_port_dev *seg30;
	alt_up_parallel_port_dev *seg74;

	ledr = alt_up_parallel_port_open_dev(LEDR_NAME);
	switches =  alt_up_parallel_port_open_dev(SWITCHES_NAME);
	seg30 = alt_up_parallel_port_open_dev(SEG30_NAME);
	seg74 = alt_up_parallel_port_open_dev(SEG74_NAME);


	// open the Character LCD port
	char_lcd_dev = alt_up_character_lcd_open_dev (LCD_NAME);
	if( char_lcd_dev == NULL) alt_printf ("Error: could not open character LCD device\n");
	else alt_printf ("Opened character LCD device\n");
	/* Initialize the character display */
	alt_up_character_lcd_init (char_lcd_dev);
	/* Write "Welcome to" in the first row */
	alt_up_character_lcd_string(char_lcd_dev, "Witamy");
	/* Write "the DE2 board" in the second row */
	char second_row[] = "na plycie DE2\0";
	alt_up_character_lcd_set_cursor_pos(char_lcd_dev, 0, 1);
	alt_up_character_lcd_string(char_lcd_dev, second_row);


  printf("Hello from Nios II!\n");

	while(1){
		usleep(1000000);
	tmp = alt_up_parallel_port_read_data(switches);
	alt_up_parallel_port_write_data(ledr, tmp);
	alt_up_parallel_port_write_data(seg30, decodeNumber(tmp));
	tmp/=10000;
	alt_up_parallel_port_write_data(seg74,decodeNumber(tmp));
	printf("%4d : %4d  |  %4x\n", tmp, decodeNumber(tmp), decodeNumber(tmp));
	}



  return 0;
}



